// Bezeichnung: Panel mit Rahmen und Titel (Groupbox)
// Autor      : Andreas Brotzmann, Peter Weigel

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import pefas.sort.*;

class GroupBox extends Panel {
	protected String Title;

	public GroupBox(String Title) {
    this(Title, new GridLayout(0, 1, 10, 10));
	}

	public GroupBox(String Title, LayoutManager lm) {
		super();
 		this.Title = Title;
 		setLayout(lm);
	}

	public Insets getInsets(){
    Insets i = new Insets(20,10,10,10);
    if (!Title.equals("")) {
      i.top += getFontMetrics(getFont()).getAscent()+getFontMetrics(getFont()).getDescent()-10;
    }
    return i;
	}

	public void paint(Graphics g){
    Dimension r = new Dimension(getFontMetrics(getFont()).stringWidth(Title), getFontMetrics(getFont()).getHeight());
    Dimension d = this.getSize();
		int orgy = r.height/2;

		g.setColor(getBackground().brighter());
		g.drawLine(0, orgy+1, d.width-1, orgy+1);
		g.drawLine(1, orgy+1, 1, d.height-1);
		g.drawLine(0, d.height-1, d.width-1, d.height-1);
		g.drawLine(d.width-1, orgy, d.width-1, d.height-1);

		g.setColor(getBackground().darker());
		g.drawLine(0, orgy, d.width-1, orgy);
		g.drawLine(0, orgy, 0, d.height-1);
		g.drawLine(1, d.height-2, d.width-2, d.height-2);
		g.drawLine(d.width-2, orgy+1, d.width-2, d.height-2);

		if (!Title.equals("")) {
      g.setColor(getBackground());
		  g.fillRect(10,0,r.width+2, r.height);
    }

		g.setColor(getForeground());
		g.drawString(Title, 11, getFontMetrics(getFont()).getAscent());
	}
}
