// Peter Weigel

// Bsort
// Variante 3

package pefas.sort;

import pefas.field.ifield;

public class bsort3 extends sort {
  protected int k = 1;

  public void sort(ifield A, int l, int r) {
    node_head    root = null;
    node_element top;
    for (int i=r;i>=l;i--) {
      top = insert(A, root, new node_element(i));
      if (top != null) {
        root = new node_head(1, root, top);
      }
    }
    //check(root);
    int[][] B = new int[2][r+1]; // mit integriertem Tepif
    for (int i=l;i<=r;i++) {
      B[0][i] = i;
      B[1][i] = i;
    }
    resolve(A, B, l, root);
  }

  private abstract class node {
    public node_element next;
    public node_head    child;
  }

  protected class node_element extends node {
    public int index;
    public node_element(int index) {
      this.index = index;
      this.child = null;
      this.next  = null;
    }
  }

  protected class node_head extends node {
    public int count;
    public node_head(int count, node_head child, node_element first) {
      this.count = count;
      this.child = child;
      this.next  = first;
    }
  }

  protected node find_ge(ifield A, node_head head, node_element e) { // Find element before element which is greater or equal
    node prev = head;
    while ((prev.next != null) && (A.gt(e.index, prev.next.index))) {
      prev = prev.next;
    }
    return prev;
  }

  protected node find_n(node_head head, int i) { // Find element on position i (0=head)
    node prev = head;
    int j = 0;
    while (j < i) {
      prev = prev.next;
      j++;
    }
    return prev;
  }

  protected node_element split(node_head head) { // Split node
    node prev           = find_n(head, k);
    node_element parent = prev.next;
    prev.next           = null;
    head.count          = k;
    parent.child        = new node_head(k, parent.child, parent.next);
    parent.next         = null;
    return parent;
  }

  protected node_element insert(ifield A, node_head head, node_element e) { // Fgt ein Element ein
    if (head != null) {
      node prev = find_ge(A, head, e); // Korrekte Position im aktuellen Knoten suchen
      e = insert(A, prev.child, e);  // Wenn es noch Kinder gibt, dann suche dort weiter, evtl. bekommen wir aber was zurck (siehe split)...
      if (e != null) {
        e.next    = prev.next;  // Element e echt einfgen
        prev.next = e;
        head.count++;
        if (head.count > 2*k) { // Ein Split ist ntig!
          e = split(head);   // und es kommt was zurck...
        } else {
          e = null;
        }
      }
    }
    return e;
  }

  protected int resolve(ifield A, int[][] B, int index, node_head head) { // Baum auflsen
    if (head != null) {
      node current = head;
      while (current != null) {
        index   = resolve(A, B, index, current.child);
        if (current.next != null) {
          int s = B[0][current.next.index];
          int t = B[1][index];
          A.exchange(s, index);
          B[0][t] = s;
          B[1][s] = t;
          index++;
        }
        current = current.next;
      }
    }
    return index;
  }

  /*int node_count;
  int element_count;

  protected void check(node_head head) { // Testen
   node_count = 0;
   element_count = 0;
   check_intern(head);
   System.out.println("Knoten: "+node_count+", Elemente: "+element_count+" Belegung: "+(float)element_count/node_count/2/k);
  }

  protected void check_intern(node_head head) { // Testen
    if (head != null) {
      node_count++;
      element_count += head.count;
      node current = head;
      while (current != null) {
        check_intern(current.child);
        if (current.next != null) {
          //
        }
        current = current.next;
      }
    }
  }*/


}
