// Bezeichnung: Visuelle Punkte
// Autor      : Peter Weigel, Andreas Brotzmann

import pefas.field.*;
import java.awt.*;

class ptele {
  protected static int size = 2;
  protected int value;          // Wert == absolute Y-Koordinate
  protected int index;          // Index == absolute X-Koordinate
  protected Point p;            // echte Position
  protected Dimension d;        // zuletzt bekannte Gre der Zeichenflche
  protected ptfield field;      // Unser Feld (Anwendung fr Update-Status und Nachbarfindung)
  protected int fl;             // und seine zuletzt bekannte Gre

  public ptele(int value, ptfield field) {
    this.value = value;
    this.index = -1;
    this.p = null;
    this.d = null;
    this.field = field;
    this.fl = 0;
  }

  public int value() {                            // Wert ermitteln
    return value;
  }

  public boolean lessthan(ptele ele) {            // Vergleich auf kleiner
    return (this.value() < (ele.value()));
  }

  public boolean equal(ptele ele) {               // Vergleich auf Gleichheit
    return (this.value() == (ele.value()));
  }

  public String toString() {
    return new Integer(value()).toString();
  }

  public synchronized void setIndex(int index) {
    recalc();
    Point s = calcPoint(index);
    if ((p != null) && ((!p.equals(s) || (index == value))) && (field.update == 0)) {     // echt neue Position?
      int cindex = index;                                           // Aktuellen Index finden
      if (index == -1) { cindex = this.index; }
      int epp = field.length/(d.width-size)+1;                      // elements per pixel berechnen
      boolean flag = true;                                          // Werden wir vollstndig berdeckt?
      for (int i= this.index-epp+1;i<=this.index+epp-1;i++) {
        if ((i>=0) && (i != cindex) && (i<field.length) && (p.equals(field.items[i].p))) {
          flag = false;
        }
      }
      if (flag == true) {                                           // Wenn nicht, dann vollstndig lschen
        hide();
        epp *= (size+1);
        for (int i= this.index-epp+1;i<=this.index+epp-1;i++) {     // und alle anderen neu zeichnen lassen
          if ((i>=0) && (i != cindex) && (i<field.length)) {
            field.items[i].refresh(p);
          }
        }
      }
      p = null;
    }
    this.index = index;
  }

  public Point point() {
    return p;
  }

  protected boolean recalc() {
    if (!field.d.equals(d)){
      d = field.d;
      p = null;
    }
    if (fl != field.length) { // Neuberechnung erzwingen
      fl = field.length;
      p = null;
    }
    return (p == null);
  }

  protected Point calcPoint(int index) {
    if (fl > 1) {
      return new Point((d.width-size-1)*index/(fl-1), (d.height-size-1)-(d.height-size-1)*value/(fl-1));
    } else {
      return new Point(0,0);
    }
  }

  protected synchronized void hide() {
    if (field.g != null) {
      field.g.clearRect(p.x, p.y, size+1, size+1);
    }
  }

  public synchronized void refresh() { // Position neu berechnen und immer neu zeichen
    if ((index >= 0) && (field.update == 0)) {
      if (recalc()) {
        p = calcPoint(index);
      }
      if (field.g != null) {
        if (index == value) {field.g.setColor(field.sortColor); }
        else                {field.g.setColor(field.pointColor); }
        field.g.drawRect(p.x, p.y, size, size);
      }
    }
  }

  protected synchronized void refresh(Point pt) { //Nur neu zeichnen, wenn im betroffenen Gebiet
    if ((p != null) && (pt != null) && (pt.x+size>=p.x) && (pt.y+size>=p.y) && (pt.x<=p.x+size) && (pt.y<=p.y+size)) {
      refresh();
    }
  }

  public synchronized void paint() { //Nur neu zeichnen, wenn unbedingt ntig
    if (p == null) { refresh(); }
 	}

}
