// Bezeichnung: Hauptfenster (Frame)
// Autor      : Andreas Brotzmann, Peter Weigel

import java.io.*;
import java.awt.*;
import java.awt.event.*;

class vasa extends Frame implements WindowListener { // Hauptfenster
  protected ControlPanel control;
  protected Panel sortpanel;
  protected ptfield field;
  protected static vasa MainWindow = null;
  protected boolean applet;
  protected boolean reactivate;

  public vasa(boolean applet, boolean reactivate) {
    super(vasa.title());
    this.MainWindow = this;
    this.applet = applet;
    this.reactivate = reactivate;
    setBackground(SystemColor.control);
    addWindowListener(this);

    setLayout (new BorderLayout());
    field = new ptfield(8192);
		sortpanel = new BorderPanel(new BorderLayout());
		sortpanel.add(field, "Center");
    control = new ControlPanel(field);

    add(control, "East");      // Menu (rechte Seite)
    add(sortpanel,"Center");   // Punktefeld

    setLocation(0, 0);
    pack();
    setVisible(true);
  }

  public void windowClosed(WindowEvent ev) {}
  public void windowDeiconified(WindowEvent ev) {}
  public void windowIconified(WindowEvent ev) {}
  public void windowActivated(WindowEvent ev) {}
  public void windowDeactivated(WindowEvent ev) {}
  public void windowOpened(WindowEvent ev) {}
  public void windowClosing(WindowEvent ev) {exit();}

  public void exit() {
    control.abort();
    if (reactivate == true) {
      setVisible(false);
    } else {
      dispose();
      if (applet == false) {
        System.exit(0);
      }
    }
  }

  public static String title()   {return "VASA - Visualisierung allgemeiner Sortieralgorithmen";}
  public static String version() {return "1.25 (05.03.2002)";}
  public static String autor()   {return "Peter Weigel, Andreas Brotzmann";}
  public static String url()     {return "http://www.sortieralgorithmen.de";}
  public static String email()   {return "vasa@sortieralgorithmen.de";}

  public static void main(String arg[]){
    System.out.print("VASA wird gestartet...");
    new vasa(false, false);
    System.out.println("OK");
  }
}


